Bug 1412149 - time does not show really consumed time
Summary: time does not show really consumed time
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: time
Version: 7.3
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Petr Pisar
QA Contact: BaseOS QE - Apps
URL: http://lists.gnu.org/archive/html/bug...
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-11 12:00 UTC by Petr Pisar
Modified: 2018-03-02 14:54 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: No Doc Update
Doc Text:
undefined
Clone Of: 1004416
Environment:
Last Closed: 2018-03-02 14:54:36 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description Petr Pisar 2017-01-11 12:00:48 UTC
+++ This bug was initially created as a clone of Bug #1004416 +++

Description of problem:
Hi, then problem is based on
https://bugzilla.redhat.com/show_bug.cgi?id=960570
I've tried to use time to measure problem, but time itself is not able to deal with time shift and show incorrent result



How reproducible:
100%

Steps to Reproduce:
# CONST=70
# W=3
# time sleep $CONST& 
# BPID=$!
# sleep $W
# DOLD=`date`
# date -s "now - 1 minute"
# wait $BPID
# date -s "now + 1 minute"
# DNEW=`date`
# let DIFF=(`date +%s -d "$DNEW"` - `date +%s -d "$DOLD"`)
# echo $(($DIFF+$W)) == $CONST

Actual results:
time difference is 70 sec 
but time show:
real	0m10.001s
user	0m0.000s
sys	0m0.001s


Expected results:
real	1m10.001s

   Thanks&Regards
   Honza


--- Additional comment from Petr Pisar on 2013-09-09 12:24:20 GMT ---

Despite you use built-in `time', there is the same problem with GNU time.

I also think that time should measure monotonic (-alike) time not to get influenced by shifts in system clock.

clock_gettime(2) offers:

CLOCK_MONOTONIC -- suffers from NTP time adjustment.
CLOCK_MONOTONIC_RAW -- uses real hardware clock, I worry about precision and access permission for non-root users.
CLOCK_BOOTTIME -- includes time elapsed in suspension but suffers from NTP time adjustment. Is it worth?

I guess the CLOCK_MONOTONIC_RAW is the most appropriate.

--- Additional comment from Petr Pisar on 2014-10-21 13:15:50 GMT ---

Upstream agreed to use clock_gettime(CLOCK_MONOTONIC) for measuring the "real" value.

[...]

Patches posted to upstream <http://lists.gnu.org/archive/html/bug-gnu-utils/2016-12/msg00000.html>, but upstream seems dead.

Comment 1 Petr Pisar 2018-03-02 14:54:36 UTC
We do not plan to fix this issue in RHEL-7. If you are affected, please escalate it to Red Hat support with reference to this bug report.


Note You need to log in before you can comment on or make changes to this bug.